function Opl00100LoteDeEnvioDePedidosDoOL_Controller(ScreenService, templateManager, ZhFilterPreferences, General, restEngine, ZhReports) {
    
    this.openFilter = function(widget) {
    	ScreenService.showLoader();
        this.setFieldsGerais(widget);
        var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		rowsToSet.TCDLOTENVITOL = 'T';
		widget.getField("P_CDLOTENVITOL").filterProperties.readOnly = true;
		widget.getField("P_CDLOTENVITOL").filterProperties.readOnlyOnEdit = true;
		delete widget.getField("P_CDLOTENVITOL").filterProperties.validations.required;
		delete widget.getField("P_CDLOTENVITOL").validations.required;
		
		ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
			ScreenService.hideLoader();
		}).catch(error => {
			console.log(error);
			ScreenService.hideLoader();
		});
    };

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
	
	this.changeFieldLote = function(args) {
		var widget = args.owner.field.widget;
		ScreenService.showLoader();
		if(args.row.TCDLOTENVITOL == 'T') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("P_CDLOTENVITOL").readOnly = true;
					widget.getField("P_CDLOTENVITOL").readOnlyOnEdit = true;
					delete widget.getField("P_CDLOTENVITOL").validations.required;
					widget.currentRow.P_CDLOTENVITOL = "";
					widget.currentRow.NMLOTENVITOL = "";
					widget.getField("P_CDLOTENVITOL").clearValue();
					widget.getField("P_CDLOTENVITOL").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		} else if(args.row.TCDLOTENVITOL == 'L') {
			if(widget.name === "zhFilterPreferencesSelectConditions") {
				setTimeout(() => {
					widget.getField("P_CDLOTENVITOL").readOnly = false;
					widget.getField("P_CDLOTENVITOL").readOnlyOnEdit = false;
					widget.getField("P_CDLOTENVITOL").validations.required = true;
					widget.getField("P_CDLOTENVITOL").reload();
					ScreenService.hideLoader();
				}, 200);
			}
		}
	};
	
	this.saveEdit = function(widget) {
		if(widget.isValid()) {
			widget.saveRow().then(function(){
				widget.view();
				widget.widgets[0].enabled = true;
				widget.widgets[0].reload();
			}, function(error){
				ScreenService.showMessage(error.data.error);
			});
		} else {
			console.log("DADOS INVALIDOS");
		}
	};
	
	this.newLote = function(widget) {
        widget.newRow();
        widget.getField("CDLOTENVITOL").readOnly = false;
        widget.getField("CDLOTENVITOL").validations.required = true;
        widget.getField("CDLOTENVITOL").minlength = 10;
        widget.getField("CDLOTENVITOL").maxlength = 10;
        widget.getField("CDLOTENVITOL").setValue("0000000000");
	};
	
	this.fillField = function(args) {
		var field = args.owner.field.widget.getField("CDLOTENVITOL");
		var value = field.value();
		var row = args.row;
		value = value.padStart(10, '0');
		field.setValue(value);
		field.value(value);
		row.CDLOTENVITOL = value;
		field.reload();
	};

    this.validateReport = function(widget, type) {
    	var REPORT_JSON = "./modules/consolidacao/assets/modules/solicitacao/assets/json/containers/opl00100_lote_de_envio_de_pedidos_do_OL.json";
    	
    	ScreenService.showLoader();
        restEngine.requestMetaData(REPORT_JSON).then(function(reportMetaData){
            ScreenService.hideLoader();
            console.log(reportMetaData.data);
            ZhReports.openReport(reportMetaData.data, widget, null, null, type).then(function(success) {
            	console.log(success);
            }).catch(error1 => {
            	console.log(error1);
            });
        }).catch(error => {
        	console.log(error);
        });
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Opl00100LoteDeEnvioDePedidosDoOL_Controller', Opl00100LoteDeEnvioDePedidosDoOL_Controller);
});